from emodpy_hiv.campaign.individual_intervention import MaleCircumcision
from emodpy_hiv.campaign.common import CommonInterventionParameters as CIP, PropertyRestrictions
from emodpy_hiv.utils.emod_enum import TargetDiseaseState
from emodpy_hiv.campaign.distributor import add_intervention_nchooser_df

import pandas as pd

def build_campaign(campaign):
    intervention_name = "MaleCircumcision1"
    intervention_list = [MaleCircumcision(campaign,
                                          common_intervention_parameters=CIP(intervention_name=intervention_name))]
    distribution_df = pd.DataFrame({
        'year': [2010, 2010, 2011, 2011],
        'min_age': [1, 15, 1, 15],
        'max_age': [14.999, 49.999, 14.999, 49.999],
        'num_targeted_female': [200, 1300, 290, 1490],
        'num_targeted_male': [1200, 300, 1290, 490]
    })
    property_restrictions = PropertyRestrictions(individual_property_restrictions=[["Risk: High"]])
    target_disease_state = [[TargetDiseaseState.HIV_POSITIVE, TargetDiseaseState.NOT_HAVE_INTERVENTION]]
    event_name = "TestEvent"
    node_ids = [1, 2, 3]
    add_intervention_nchooser_df(campaign,
                                 intervention_list=intervention_list,
                                 distribution_df=distribution_df,
                                 property_restrictions=property_restrictions,
                                 target_disease_state=target_disease_state,
                                 target_disease_state_has_intervention_name=intervention_name,
                                 event_name=event_name,
                                 node_ids=node_ids)
    intervention_name = "MaleCircumcision2"
    intervention_list = [MaleCircumcision(campaign,
                                          common_intervention_parameters=CIP(intervention_name=intervention_name))]
    property_restrictions = PropertyRestrictions(individual_property_restrictions=[["Risk: High"]])
    target_disease_state = [[TargetDiseaseState.HIV_POSITIVE, TargetDiseaseState.NOT_HAVE_INTERVENTION]]
    event_name = "TestEvent"
    node_ids = None # None means all nodes
    add_intervention_nchooser_df(campaign,
                                 intervention_list=intervention_list,
                                 distribution_df=distribution_df,
                                 property_restrictions=property_restrictions,
                                 target_disease_state=target_disease_state,
                                 target_disease_state_has_intervention_name=intervention_name,
                                 event_name=event_name,
                                 node_ids=node_ids)

    return campaign