from emodpy_hiv.campaign.individual_intervention import MaleCircumcision
from emodpy_hiv.campaign.common import TargetDemographicsConfig, PropertyRestrictions, TargetGender, ValueMap, CommonInterventionParameters
from emodpy_hiv.campaign.distributor import add_intervention_reference_tracking
from emodpy_hiv.utils.targeting_config import HasIntervention, IsHivPositive


def build_campaign(campaign):
    malecirc_intervention_name = "ANY_MC"
    distribute_circumcision = MaleCircumcision(campaign,
                                               circumcision_reduced_acquire=0.7,
                                               distributed_event_trigger="PROGRAM_VMMC",
                                               common_intervention_parameters=CommonInterventionParameters(
                                                   intervention_name=malecirc_intervention_name))
    targeting_config = ~IsHivPositive()
    tracking_config = HasIntervention(intervention_name=malecirc_intervention_name)
    add_intervention_reference_tracking(campaign,
                                        intervention_list=[distribute_circumcision],
                                        time_value_map=ValueMap(times=[1960, 1961],
                                                                values=[0.1, 0.3]),
                                        tracking_config=tracking_config,
                                        start_year=1960,
                                        update_period=1962,
                                        target_demographics_config=TargetDemographicsConfig(
                                            target_gender=TargetGender.MALE,
                                            demographic_coverage=None),
                                        targeting_config=targeting_config,
                                        event_name='Reference tracking of VMMC',
                                        node_ids=None)
    return campaign
